import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Boomerang here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Boomerang extends BaseActor
{
    double dx;
    double dy;
    Thrower thrower;
    int age = 0;
    public Boomerang(Thrower thrower,int direction) {
        switch(direction) {
            case 0 : dx = thrower.getSpeed()*-2;
            case 1 : dx = thrower.getSpeed()*2;
            case 2 : dy = thrower.getSpeed()*-2;
            case 3 : dy = thrower.getSpeed()*2;
        }
        Join.send("BoomerangEvent:"+thrower.getID()+";"+direction+";"+getWorldX()+";"+getWorldY());
    }

    boolean flying = true;
    public void run() 
    {
        if(age > 1000) {
            dx=-dx;
            dy=-dy;
        }
        if(flying) setLocation(getExactX()+dx,getExactY()+dy); 

        if(isTouching(BaseActor.class) && flying) {
            BaseActor a = getOneIntersectingObject(BaseActor.class);
            if(a instanceof Damageable) {
                Damageable d = (Damageable) a;
                if(d == thrower ) {
                    return;
                }
                d.damage(thrower.getAttack());
                flying = false;
            }else if(a instanceof Obstacle) {
                flying = false;
            }else {
                System.out.println("a boomerang hit a " + a.getClass());
            }
        }   

        if(isTouching(Thrower.class)) {
            Thrower t = (Thrower) getOneIntersectingObject(Thrower.class);
            if(t == thrower) {
                t.setAmmo(t.getAmmo()+1);
                getWorld().removeObject(this);
            }
        }
    }
}
